<template>
  <el-main>
    <!--行政处罚案件结案报告-->
    <el-form ref="form" :model="form" :disabled="form.registerState == '1'">
      <el-form-item label="案由" :label-width="formLabelWidth">
        <el-input v-model="form.casePoint" autocomplete="off"></el-input>
      </el-form-item>

      <el-form-item label="案件来源" :label-width="formLabelWidth">
        <el-input v-model="form.caseSource" autocomplete="off"></el-input>
      </el-form-item>

      <el-row>
        <el-col :span="12">
          <el-form-item
            label="当事人姓名"
            :label-width="formLabelWidth"
          >
            <el-input v-model="form.litigant" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="法定代表人" :label-width="formLabelWidth">
            <el-input v-model="form.legalPerson" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="证件名称" :label-width="formLabelWidth">
            <el-select v-model="form.litigantCert" placeholder="请选择当事人证件类型"
                       :disabled="form.registerState == '1'" style="width: 100%;">
              <el-option
                v-for="item in cardList"
                :label="item.label"
                :value="item.value">
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="证件号码" :label-width="formLabelWidth">
            <el-input v-model="form.certNo" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item label="住址" :label-width="formLabelWidth">
        <el-input v-model="form.address" autocomplete="off"></el-input>
      </el-form-item>

      <el-row>
        <el-col :span="12">
          <el-form-item label="电话" :label-width="formLabelWidth">
            <el-input v-model="form.phone" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="发案时间" :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.crimeTime"
              type="date"
              :value-format="`yyyy-MM-dd`"
              style="width: 100%"
              placeholder="选择日期"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="立案时间" :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.recordTime"
              type="date"
              :value-format="`yyyy-MM-dd`"
              style="width: 100%"
              placeholder="选择日期"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item label="案发地点" :label-width="formLabelWidth">
        <el-input v-model="form.crimeAddress" autocomplete="off"></el-input>
      </el-form-item>

<!--      <el-row>-->
<!--        <el-col :span="12">-->
          <el-form-item label="承办人及执法证号" :label-width="formLabelWidth">
            <el-input v-model="form.undertakerName" autocomplete="off"></el-input>
          </el-form-item>
<!--        </el-col>-->
<!--        <el-col :span="12">-->
<!--          <el-form-item label="执法证号" :label-width="formLabelWidth">-->
<!--            <el-input v-model="form.undertakerCard" autocomplete="off"></el-input>-->
<!--          </el-form-item>-->
<!--        </el-col>-->
<!--      </el-row>-->

      <el-row>
        <el-col :span="12">
          <el-form-item label="结案情形" :label-width="formLabelWidth">
            <el-select v-model="form.caseSituation" placeholder="请选择结案情形类型"
                       style="width: 100%;" @change="changeValue">
              <el-option
                v-for="item in closeCases"
                :label="item.label"
                :value="item.value">
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="其他" :label-width="formLabelWidth" v-show="caseSituationOtheyes">
            <el-input v-model="form.caseSituationOthers" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item label="处罚决定书文号" :label-width="formLabelWidth">
        <el-input v-model="form.documentNum" autocomplete="off"></el-input>
      </el-form-item>

      <el-form-item label="行政处罚内容" :label-width="formLabelWidth">
        <el-input type="textarea" v-model="form.penaltyDecision" autocomplete="off"></el-input>
      </el-form-item>

      <el-row>
        <el-col :span="12">
          <el-form-item label="决定执行方式" :label-width="formLabelWidth">
            <el-select v-model="form.enforcementMethod" placeholder="请选择决定执行方式"
                       style="width: 100%;" @change="changes">
              <el-option
                v-for="item in punishModes"
                :label="item.label"
                :value="item.value">
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="其他" :label-width="formLabelWidth" v-show="otherMethodes">
            <el-input v-model="form.otherMethod"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="财物处置情况" :label-width="formLabelWidth">
        <el-input type="textarea" v-model="form.penaltyDecisionCase"></el-input>
      </el-form-item>
      <public-opinion ref="publicOpinion" :registerState="form.registerState"></public-opinion>
      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </el-form>
    <div style="text-align: center;">
      <el-button v-show="form.registerState != '1'" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-show="form.registerState != '1'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(form)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(form)">下载</el-button>
    </div>
  </el-main>
</template>

<script>
import publicOpinion from "@/views/News/publicOpinion"
import WordView from "@/views/News/word-view";
import {getObj, saveObj} from "@/api/News/finalReport";
import moment from "moment";
import {remote} from "@/api/admin/dict"

export default {
  name: "finalReport",
  props: ['isShowYulan', 'id', 'isFinish', 'processId'],
  components: {
    WordView,
    publicOpinion
  },
  data() {
    return {
      showView: false,
      otherMethodes:false,
      caseSituationOtheyes:false,
      form: {
        casePoint: "",
        caseSource: "",
        litigant: "",
        legalPerson: "",
        litigantCert: "",
        certNo: "",
        address:"",
        phone:"",
        crimeTime:"",
        recordTime:"",
        crimeAddress:"",
        undertakerName:"",
        undertakerCard:"",
        caseSituation:"",
        caseSituationOthers:"",
        documentNum:"",
        penaltyDecision:"",
        enforcementMethod:"",
        otherMethod:"",
        penaltyDecisionCase:"",
      },
      cardList: [],
      closeCases:[],
      punishModes:[],
      formLabelWidth: "134px",
      imgSize : {     //控制导出的word图片大小
          autographOne: [120, 35],
          autographTwo: [120, 35],
          autographDept: [120, 35],
          autographLegal: [120, 35],
          autographOrgan: [120, 35]
      }
    };
  },
  created() {
    this.init()
  },
  methods: {
    init() {
      //查询证件类型字典
      remote('document_type').then(res => {
        this.cardList = res.data.data;
      });
      //结案情形
      remote('case_closed').then(res => {
        this.closeCases = res.data.data;
      });
      //执行方式
      remote('punish_moded').then(res => {
        this.punishModes = res.data.data;
      });
      getObj(this.id).then((res) => {
        // 转换null为""
        /*let v = res.data.data;
        for (let attr in v) {
          if (v[attr] == null) {
            v[attr] = "";
          }
        }
        let str = JSON.stringify(v);
        let data = JSON.parse(str);*/
        this.form = res.data.data;
        this.$nextTick(() => {
          this.$refs.publicOpinion.init(this.form.publicOpinion);
        })
      });
    },
    changeValue(value){
      if (value == '其他'||this.form.caseSituation =='其他'){
        this.caseSituationOtheyes = true;
      }else {
        this.caseSituationOtheyes = false;
      }
    },
    changes(value){
      console.log(value,'value')
      if (value == '其他：'||this.form.enforcementMethod =='其他'){
        this.otherMethodes = true;
      }else {
        this.otherMethodes = false;
      }
    },
    dataFormSubmit(type) {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.form.registerState = type;
              obj.form.registerId = obj.id;
              obj.form.processId = obj.processId;
              saveObj(obj.form).then((res) => {
                // this.submitLoading = false;
                obj.$message.success('操作成功');
                obj.cancel();
              })
            })
          } else {
            obj.form.registerState = type;
            obj.form.registerId = obj.id;
            obj.form.processId = obj.processId;
            saveObj(obj.form).then((res) => {
              // this.submitLoading = false;
              obj.$message.success("操作成功");
              obj.cancel();
            })
          }
        }
      })
    },
    cancel() {
      this.$emit('cancel', false);
    },
    cancelWord() {
      this.showView = false;
    },
    viewVord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //格式转换
      let wordData = this.transforData(data);

      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      this.showView = true;
        let arry = ['autographOne', 'autographTwo', 'autographDept', 'autographLegal', 'autographOrgan']
      this.$nextTick(() => {
        this.$refs.wordInfo.initMore(wordData, "/wordes/finalReport.docx",arry, this.imgSize);
      })
    },
    downloadWord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      let wordData = this.transforData(data);
        let arry = ['autographOne', 'autographTwo', 'autographDept', 'autographLegal', 'autographOrgan']
        this.$nextTick(() => {
            this.$refs.wordInfo.exportDocMore(wordData, "/wordes/finalReport.docx", "行政处罚案件结案报告.docx",arry, this.imgSize);
        })

    },
    transforData(obj) {
      let s = JSON.stringify(obj);
      let data = JSON.parse(s);
      if (data.undertakerName != null && data.undertakerName.indexOf(",")){
        data.undertakerName = data.undertakerName.replace(",","\n");
      }
      if (data.caseSituation == "行政处罚决定执行完毕"){
          data.xing = true;
          data.zheng = false;
      }else {
        data.xing = false;
        data.zheng = true;
      }
      if (data.caseSituation == "人民法院裁定终结执行"){
          data.ren = true;
          data.min = false;
      }else {
        data.ren = false;
        data.min = true;
      }
      if (data.caseSituation == "案件终止调查"){
        data.an = true;
        data.jian = false;
      }else {
        data.an = false;
        data.jian = true;
      }
      if (data.caseSituation == "不予行政处罚"){
        data.bu = true;
        data.yu = false;
      }else {
        data.bu = false;
        data.yu = true;
      }
      if (data.caseSituation == "违法事实不能成立"){
        data.wei = true;
        data.fa = false;
      }else {
        data.wei = false;
        data.fa = true;
      }
      if (data.caseSituation == "移送其他行政管理部门"){
        data.guan = true;
        data.li = false;
      }else {
        data.guan = false;
        data.li = true;
      }
      if (data.caseSituation == "移送司法机关"){
        data.yi = true;
        data.song = false;
      }else {
        data.yi = false;
        data.song = true;
      }
      if (data.caseSituation == "其他"){
        data.qi = true;
        data.ta = false;
      }else {
        data.qi = false;
        data.ta = true;
      }

      if (data.enforcementMethod == "主动履行"){
        data.zhu = true;
        data.dong = false;
      }else {
        data.zhu = false;
        data.dong = true;
      }
      if (data.enforcementMethod == "强制执行"){
        data.qiang = true;
        data.zhi = false;
      }else {
        data.qiang = false;
        data.zhi = true;
      }
      if (data.enforcementMethod == "其他"){
        data.qii = true;
        data.taa = false;
      }else {
        data.qii = false;
        data.taa = true;
      }
      if (data.crimeTime != '' && data.crimeTime != null) {
        data.crimeTime = moment(data.crimeTime).format('YYYY年MM月DD日');
      }
      if (data.recordTime != '' && data.recordTime != null) {
        data.recordTime = moment(data.recordTime).format('YYYY年MM月DD日');
      }
      let opinion = data.publicOpinion;
      for (let attr in opinion) {
        if (opinion[attr] == null) {
          data[attr] = '';
        } else {
          data[attr] = opinion[attr];
        }
      }
      // let str = JSON.stringify(data);
      // let jsonData = JSON.parse(str);
      // data = jsonData;

      if (opinion.undertakeDate != '' && opinion.undertakeDate != null) {
        data.undertakeDate = moment(opinion.undertakeDate).format('YYYY年MM月DD日');
      } else {
        data.undertakeDate = '  年  月  日'
      }
      if (opinion.takeDate != '' && opinion.takeDate != null) {
        data.takeDate = moment(opinion.takeDate).format('YYYY年MM月DD日');
      } else {
        data.takeDate = '  年  月  日'
      }
      if (opinion.legalDate != '' && opinion.legalDate != null) {
        data.legalDate = moment(opinion.legalDate).format('YYYY年MM月DD日');
      } else {
        data.legalDate = '  年  月  日'
      }
      if (opinion.organDate != '' && opinion.organDate != null) {
        data.organDate = moment(opinion.organDate).format('YYYY年MM月DD日');
      } else {
        data.organDate = '  年  月  日'
      }
      return data;
    },
  }
}
</script>

<style scoped>

</style>
